classdef SelectSwitchMenu
    %SELECTSWITCHMENU Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        handle
    end
    
    methods
        
        function obj = SelectSwitchMenu(parent , sessiondata , varargin)
            obj.handle = uimenu(parent ,'Label'  , 'Switches' , varargin{:});
            
            sw = fieldnames(sessiondata.data.opt);
            
            for i = 1:length(sw)
                uimenu(obj.handle , 'Label' , sw{i} , 'Checked' , bool2str(sessiondata.data.opt.(sw{i})) , 'Callback' , @(o,e) callback(o, sessiondata , sw{i})  );
            
            end
        end
    end
    
end

function result = bool2str( bool)
if  (bool)
    result = 'on';
else
    result = 'off';
end
end


function callback(handle , sessiondata, label)
    val = ~ strcmp(get(handle , 'Checked'),'on');
    sessiondata.data.opt.(label) = val;
    set(handle , 'Checked' , bool2str(val));
end